<ng-template [ngIf]="dataSource.data.length > 0">
    <mat-tree [dataSource]="dataSource" [treeControl]="treeControl" class="rocket-tree">
        <!-- NODES WITH NO CHILDREN -->
        <mat-tree-node *matTreeNodeDef="let node" matTreeNodeToggle>
            <div class="rocket-tree-node">
                <div class="rocket-tree-node-header">
                    <div>
                        <h2 class="tree-node-name">{{node.name}}</h2>
                    </div>
                    <div>
                        <button mat-icon-button matTooltip="Delete node" color="warn"
                            (click)="openDeleteNodeDialog(node)">
                            <mat-icon>delete</mat-icon>
                        </button>
                    </div>
                </div>
                <div class="rocket-tree-node-properties">
                    <ng-template *ngTemplateOutlet="nodeProperties; context: {$implicit: node}" />
                </div>
            </div>
        </mat-tree-node> <!-- END NODES WITH NO CHILDREN -->
        <!-- NODES WITH CHILDREN -->
        <mat-nested-tree-node *matTreeNodeDef="let node; when: hasChild">
            <div class="rocket-tree-node">
                <div class="rocket-tree-node-header">
                    <div>
                        <button mat-icon-button matTreeNodeToggle color="primary"
                            [attr.aria-label]="'Toggle ' + node.name">
                            <mat-icon class="mat-icon-rtl-mirror">
                                {{treeControl.isExpanded(node) ? "expand_more" : "chevron_right"}}
                            </mat-icon>
                        </button>
                        <h2 class="tree-node-name">{{node.name}}</h2>
                    </div>
                    <div>
                        <button mat-icon-button matTooltip="Delete node" color="warn"
                            (click)="openDeleteNodeDialog(node)">
                            <mat-icon>delete</mat-icon>
                        </button>
                    </div>
                </div>
                <div class="rocket-tree-node-properties">
                    <ng-template [ngIf]="node.properties"
                        *ngTemplateOutlet="nodeProperties; context: {$implicit: node}" />
                </div>
            </div>
            <div [class.rocket-tree-invisible]="!treeControl.isExpanded(node)" role="group">
                <ng-container matTreeNodeOutlet></ng-container>
            </div>
        </mat-nested-tree-node> <!-- END NODES WITH NO CHILDREN -->
    </mat-tree>
</ng-template>

<ng-template #nodeProperties let-node>
    <div>
        <table class="rocket-tree-node-property-tbl">
            <tbody>
                <tr>
                    <td colspan="2">Created {{node.created|timeSince}}...</td>
                </tr>
                <ng-template ngFor let-propKey [ngForOf]="getNodePropertyKeys(node.properties)">
                    <tr>
                        <td [ngClass]="{'greater-than-ten': node.properties[propKey]> 10}">
                            {{propKey}}:
                        </td>
                        <td>{{node.properties[propKey]}}</td>
                    </tr>
                </ng-template>
            </tbody>
        </table>
    </div>
</ng-template>